3 # git-submodules.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b branch] [-f|--force] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] update [--init] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
12 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
13 or: $dashless [--quiet] foreach [--recursive] <command>
14 or: $dashless [--quiet] sync [--] [<path>...]"
33 # Resolve relative url by appending to parent's url
34 resolve_relative_url ()
36 remote=$(get_default_remote)
37 remoteurl=$(git config "remote.$remote.url") ||
38 remoteurl=$(pwd) # the repository is its own authoritative upstream
40 remoteurl=${remoteurl%/}
49 remoteurl="${remoteurl%/*}"
52 remoteurl="${remoteurl%:*}"
56 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
67 echo "$remoteurl$sep${url%/}"
71 # Get submodule info for registered submodules
72 # $@ = path to limit submodule list
76 git ls-files --error-unmatch --stage -- "$@" |
79 my ($null_sha1) = ("0" x 40);
82 my ($mode, $sha1, $stage, $path) =
83 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
84 next unless $mode eq "160000";
86 if (!$unmerged{$path}++) {
87 print "$mode $null_sha1 U\t$path\n";
97 # Map submodule path to submodule name
103 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
104 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
105 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
106 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
108 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$path'")"
115 # Prior to calling, cmd_update checks that a possibly existing
116 # path is not a git repository.
117 # Likewise, cmd_add checks that path does not exist at all,
118 # since it is the location of a new submodule.
126 if test -n "$GIT_QUIET"
133 name=$(module_name "$path" 2>/dev/null)
134 test -n "$name" || name="$path"
135 base_path=$(dirname "$path")
137 gitdir=$(git rev-parse --git-dir)
138 gitdir_base="$gitdir/modules/$base_path"
139 gitdir="$gitdir/modules/$path"
143 a="$(cd_to_toplevel && pwd)/"
145 while [ "$b" ] && [ "${a%%/*}" = "${b%%/*}" ]
151 rel=`echo $rel | sed -e 's|[^/]*|..|g'`
155 rel=`echo $name | sed -e 's|[^/]*|..|g'`
156 rel_gitdir="$rel/$gitdir"
163 echo "gitdir: $rel_gitdir" >"$path/.git"
164 rm -f "$gitdir/index"
166 mkdir -p "$gitdir_base"
167 if test -n "$reference"
169 git-clone $quiet "$reference" -n "$url" "$path" --separate-git-dir "$gitdir"
171 git-clone $quiet -n "$url" "$path" --separate-git-dir "$gitdir"
173 die "$(eval_gettext "Clone of '\$url' into submodule path '\$path' failed")"
178 # Add a new submodule to the working tree, .gitmodules and the index
182 # optional branch is stored in global branch variable
186 # parse $args after "submodule ... add".
191 case "$2" in '') usage ;; esac
202 case "$2" in '') usage ;; esac
203 reference="--reference=$2"
227 if test -z "$path"; then
228 path=$(echo "$repo" |
229 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
232 if test -z "$repo" -o -z "$path"; then
236 # assure repo is absolute or relative to parent
239 # dereference source url relative to parent's url
240 realrepo=$(resolve_relative_url "$repo") || exit
247 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
252 # multiple //; leading ./; /./; /../; trailing /
253 path=$(printf '%s/\n' "$path" |
263 git ls-files --error-unmatch "$path" > /dev/null 2>&1 &&
264 die "$(eval_gettext "'\$path' already exists in the index")"
266 if test -z "$force" && ! git add --dry-run --ignore-missing "$path" > /dev/null 2>&1
268 eval_gettextln "The following path is ignored by one of your .gitignore files:
270 Use -f if you really want to add it." >&2
274 # perhaps the path exists and is already a git repo, else clone it
277 if test -d "$path"/.git -o -f "$path"/.git
279 eval_gettextln "Adding existing repo at '\$path' to the index"
281 die "$(eval_gettext "'\$path' already exists and is not a valid git repo")"
286 module_clone "$path" "$realrepo" "$reference" || exit
290 # ash fails to wordsplit ${branch:+-b "$branch"...}
292 '') git checkout -f -q ;;
293 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
295 ) || die "$(eval_gettext "Unable to checkout submodule '\$path'")"
297 git config submodule."$path".url "$realrepo"
299 git add $force "$path" ||
300 die "$(eval_gettext "Failed to add submodule '\$path'")"
302 git config -f .gitmodules submodule."$path".path "$path" &&
303 git config -f .gitmodules submodule."$path".url "$repo" &&
304 git add --force .gitmodules ||
305 die "$(eval_gettext "Failed to register submodule '\$path'")"
309 # Execute an arbitrary command sequence in each checked out
312 # $@ = command to execute
316 # parse $args after "submodule ... foreach".
338 # dup stdin so that it can be restored when running the external
339 # command in the subshell (and a recursive call to this function)
343 while read mode sha1 stage path
345 if test -e "$path"/.git
347 say "$(eval_gettext "Entering '\$prefix\$path'")"
348 name=$(module_name "$path")
350 prefix="$prefix$path/"
354 if test -n "$recursive"
356 cmd_foreach "--recursive" "$@"
359 die "$(eval_gettext "Stopping at '\$path'; script returned non-zero status.")"
365 # Register submodules in .git/config
367 # $@ = requested paths (default to all)
371 # parse $args after "submodule ... init".
393 while read mode sha1 stage path
395 # Skip already registered paths
396 name=$(module_name "$path") || exit
397 if test -z "$(git config "submodule.$name.url")"
399 url=$(git config -f .gitmodules submodule."$name".url)
401 die "$(eval_gettext "No url found for submodule path '\$path' in .gitmodules")"
403 # Possibly a url relative to parent
406 url=$(resolve_relative_url "$url") || exit
409 git config submodule."$name".url "$url" ||
410 die "$(eval_gettext "Failed to register url for submodule path '\$path'")"
413 # Copy "update" setting when it is not set yet
414 upd="$(git config -f .gitmodules submodule."$name".update)"
416 test -n "$(git config submodule."$name".update)" ||
417 git config submodule."$name".update "$upd" ||
418 die "$(eval_gettext "Failed to register update mode for submodule path '\$path'")"
420 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$path'")"
425 # Update each submodule path to correct revision, using clone and checkout as needed
427 # $@ = requested paths (default to all)
431 # parse $args after "submodule ... update".
452 case "$2" in '') usage ;; esac
453 reference="--reference=$2"
454 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
480 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
486 cmd_init "--" "$@" || return
492 while read mode sha1 stage path
496 echo >&2 "Skipping unmerged submodule $path"
499 name=$(module_name "$path") || exit
500 url=$(git config submodule."$name".url)
501 if ! test -z "$update"
503 update_module=$update
505 update_module=$(git config submodule."$name".update)
508 if test "$update_module" = "none"
510 echo "Skipping submodule '$path'"
516 # Only mention uninitialized submodules when its
517 # path have been specified
519 say "$(eval_gettext "Submodule path '\$path' not initialized
520 Maybe you want to use 'update --init'?")"
524 if ! test -d "$path"/.git -o -f "$path"/.git
526 module_clone "$path" "$url" "$reference"|| exit
527 cloned_modules="$cloned_modules;$name"
530 subsha1=$(clear_local_git_env; cd "$path" &&
531 git rev-parse --verify HEAD) ||
532 die "$(eval_gettext "Unable to find current revision in submodule path '\$path'")"
535 if test "$subsha1" != "$sha1"
538 # If we don't already have a -f flag and the submodule has never been checked out
539 if test -z "$subsha1" -a -z "$force"
544 if test -z "$nofetch"
546 # Run fetch only if $sha1 isn't present or it
547 # is not reachable from a ref.
548 (clear_local_git_env; cd "$path" &&
549 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
550 test -z "$rev") || git-fetch)) ||
551 die "$(eval_gettext "Unable to fetch in submodule path '\$path'")"
554 # Is this something we just cloned?
555 case ";$cloned_modules;" in
557 # then there is no local change to integrate
562 case "$update_module" in
565 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$path'")"
566 say_msg="$(eval_gettext "Submodule path '\$path': rebased into '\$sha1'")"
567 must_die_on_failure=yes
571 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$path'")"
572 say_msg="$(eval_gettext "Submodule path '\$path': merged in '\$sha1'")"
573 must_die_on_failure=yes
576 command="git checkout $subforce -q"
577 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$path'")"
578 say_msg="$(eval_gettext "Submodule path '\$path': checked out '\$sha1'")"
582 if (clear_local_git_env; cd "$path" && $command "$sha1")
585 elif test -n "$must_die_on_failure"
587 die_with_status 2 "$die_msg"
589 err="${err};$die_msg"
594 if test -n "$recursive"
596 (clear_local_git_env; cd "$path" && eval cmd_update "$orig_flags")
600 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$path'")"
603 err="${err};$die_msg"
606 die_with_status $res "$die_msg"
633 git describe "$2" 2>/dev/null ||
634 git describe --tags "$2" 2>/dev/null ||
635 git describe --contains "$2" 2>/dev/null ||
636 git describe --all --always "$2"
639 test -z "$revname" || revname=" ($revname)"
642 # Show commit summary for submodules in index or working tree
644 # If '--cached' is given, show summary between index and given commit,
645 # or between working tree and given commit
647 # $@ = [commit (default 'HEAD'),] requested paths (default all)
654 # parse $args after "submodule ... summary".
668 if summary_limit=$(($2 + 0)) 2>/dev/null && test "$summary_limit" = "$2"
690 test $summary_limit = 0 && return
692 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
696 elif test -z "$1" -o "$1" = "HEAD"
698 # before the first commit: compare with an empty tree
699 head=$(git hash-object -w -t tree --stdin </dev/null)
700 test -z "$1" || shift
708 die "$(gettext -- "--cached cannot be used with --files")"
714 # Get modified modules cared by user
715 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
716 sane_egrep '^:([0-7]* )?160000' |
717 while read mod_src mod_dst sha1_src sha1_dst status name
719 # Always show modules deleted or type-changed (blob<->module)
720 test $status = D -o $status = T && echo "$name" && continue
721 # Also show added or modified modules which are checked out
722 GIT_DIR="$name/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
727 test -z "$modules" && return
729 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
730 sane_egrep '^:([0-7]* )?160000' |
732 while read mod_src mod_dst sha1_src sha1_dst status name
734 if test -z "$cached" &&
735 test $sha1_dst = 0000000000000000000000000000000000000000
739 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
741 100644 | 100755 | 120000)
742 sha1_dst=$(git hash-object $name)
748 eval_gettextln "unexpected mode \$mod_dst" >&2
755 test $mod_src = 160000 &&
756 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
759 test $mod_dst = 160000 &&
760 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
764 case "$missing_src,$missing_dst" in
766 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_src")"
769 errmsg="$(eval_gettext " Warn: \$name doesn't contain commit \$sha1_dst")"
772 errmsg="$(eval_gettext " Warn: \$name doesn't contain commits \$sha1_src and \$sha1_dst")"
777 if test $mod_src = 160000 -a $mod_dst = 160000
779 range="$sha1_src...$sha1_dst"
780 elif test $mod_src = 160000
786 GIT_DIR="$name/.git" \
787 git rev-list --first-parent $range -- | wc -l
789 total_commits=" ($(($total_commits + 0)))"
793 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
794 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
797 blob="$(gettext "blob")"
798 submodule="$(gettext "submodule")"
799 if test $mod_dst = 160000
801 echo "* $name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
803 echo "* $name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
806 echo "* $name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
810 # Don't give error msg for modification whose dst is not submodule
811 # i.e. deleted or changed to blob
812 test $mod_dst = 160000 && echo "$errmsg"
814 if test $mod_src = 160000 -a $mod_dst = 160000
817 test $summary_limit -gt 0 && limit="-$summary_limit"
818 GIT_DIR="$name/.git" \
819 git log $limit --pretty='format: %m %s' \
820 --first-parent $sha1_src...$sha1_dst
821 elif test $mod_dst = 160000
823 GIT_DIR="$name/.git" \
824 git log --pretty='format: > %s' -1 $sha1_dst
826 GIT_DIR="$name/.git" \
827 git log --pretty='format: < %s' -1 $sha1_src
833 if test -n "$for_status"; then
834 if [ -n "$files" ]; then
835 gettextln "# Submodules changed but not updated:"
837 gettextln "# Submodule changes to be committed:"
840 sed -e 's|^|# |' -e 's|^# $|#|'
846 # List all submodules, prefixed with:
847 # - submodule not initialized
848 # + different revision checked out
850 # If --cached was specified the revision in the index will be printed
851 # instead of the currently checked out revision.
853 # $@ = requested paths (default to all)
857 # parse $args after "submodule ... status".
882 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
887 while read mode sha1 stage path
889 name=$(module_name "$path") || exit
890 url=$(git config submodule."$name".url)
891 displaypath="$prefix$path"
894 say "U$sha1 $displaypath"
897 if test -z "$url" || ! test -d "$path"/.git -o -f "$path"/.git
899 say "-$sha1 $displaypath"
902 set_name_rev "$path" "$sha1"
903 if git diff-files --ignore-submodules=dirty --quiet -- "$path"
905 say " $sha1 $displaypath$revname"
909 sha1=$(clear_local_git_env; cd "$path" && git rev-parse --verify HEAD)
910 set_name_rev "$path" "$sha1"
912 say "+$sha1 $displaypath$revname"
915 if test -n "$recursive"
918 prefix="$displaypath/"
921 eval cmd_status "$orig_args"
923 die "$(eval_gettext "Failed to recurse into submodule path '\$path'")"
928 # Sync remote urls for submodules
929 # This makes the value for remote.$remote.url match the value
930 # specified in .gitmodules.
955 while read mode sha1 stage path
957 name=$(module_name "$path")
958 url=$(git config -f .gitmodules --get submodule."$name".url)
960 # Possibly a url relative to parent
963 url=$(resolve_relative_url "$url") || exit
967 if git config "submodule.$name.url" >/dev/null 2>/dev/null
969 say "$(eval_gettext "Synchronizing submodule url for '\$name'")"
970 git config submodule."$name".url "$url"
972 if test -e "$path"/.git
977 remote=$(get_default_remote)
978 git config remote."$remote".url "$url"
985 # This loop parses the command line arguments to find the
986 # subcommand name to dispatch. Parsing of the subcommand specific
987 # options are primarily done by the subcommand implementations.
988 # Subcommand specific options such as --branch and --cached are
989 # parsed here as well, for backward compatibility.
991 while test $# != 0 && test -z "$command"
994 add | foreach | init | update | status | summary | sync)
1024 # No command word defaults to "status"
1025 test -n "$command" || command=status
1027 # "-b branch" is accepted only by "add"
1028 if test -n "$branch" && test "$command" != add
1033 # "--cached" is accepted only by "status" and "summary"
1034 if test -n "$cached" && test "$command" != status -a "$command" != summary